#include <stdlib.h>
#include "dfs.h"

unsigned int
dfs_visit(unsigned int u, edge_t **Adj, unsigned int *color, 
	  unsigned int *pi, unsigned int *time, unsigned int *d,
	  unsigned int *f, list_t *list)
{
  unsigned int v, nocycle = 1;
  edge_t *edge;

  color[u] = 1;
  *time = *time + 1;
  d[u] = *time;
  edge = Adj[u];
  while (edge && nocycle) {
    v = edge->en;
    if (color[v] == 1)  
      nocycle = 0;
    if (color[v] == 0) {
      pi[v] = u;
      nocycle = dfs_visit(v, Adj, color, pi, time, d, f, list);
    }
    edge = edge->nextadj;
  }
  color[u] = 2;
  *time = *time + 1;
  f[u] = *time;
  list_append2head(list, (void *)u);
  
  return nocycle;
}

unsigned int 
dfs(unsigned int numnode, graph_t *E, edge_t **Adj, 
    unsigned int *d, unsigned int *f, list_t *list)
{
  unsigned int *color, *pi, i, time = 0, nocycle = 1;

  if ((color = (unsigned int *)calloc(numnode+1, sizeof(unsigned int))) == NULL) no_mem_exit();
  if ((pi = (unsigned int *)calloc(numnode+1, sizeof(unsigned int))) == NULL) no_mem_exit();

  for (i=1; i<=numnode; i++) {
    color[i] = 0;
    pi[i] = 0;
  }
  for (i=1; i<=numnode; i++) {
    if (color[i] == 0)
      nocycle = dfs_visit(i, Adj, color, pi, &time, d, f, list);
    if (nocycle == 0) {
      free(color);
      free(pi);
      return nocycle;
    }
  }
  
  free(color);
  free(pi);
  return nocycle;
}

