#include <stdio.h>
#include <stdlib.h>
#include "dfs.h"
#include "list_int.h"

int main()
{
  unsigned int numnode, numedge, u, v, t, p, i, num, *discover, 
    *finish, success;
  float w;
//  FILE *fp;
  graph_t *E = graph_create();
  edge_t *edge, **Adj;
  list_t *list = list_create();
  list_item *item;
  info_t *info;

//  fp=fopen("testfile","rb");
  scanf("%d%d",&numnode, &numedge);

  num = numnode + 1;
  if ((Adj = (edge_t **)malloc(num*sizeof(edge_t *))) == NULL) no_mem_exit();
  if ((discover = (unsigned int *)calloc(num, sizeof(unsigned int))) == NULL) no_mem_exit();
  if ((finish = (unsigned int *)calloc(num, sizeof(unsigned int))) == NULL) no_mem_exit();
  
  for (i=1; i<=numnode; i++) {
    Adj[i] = 0;
    discover[i] = 0;
    finish[i] = 0;
  }

  for (i=0; i<numedge; i++) {
    scanf("%d%d%f%d%d", &u, &v, &w, &t, &p);
    if ((info = (struct info *)calloc(1, sizeof(struct info))) == NULL) no_mem_exit();
    info->t = t;
    info->p = p;
    info->w = w;
    edge = graph_add_edge(E, u, v, (void *)info);
    graph_adjacent(Adj, edge);
  }
 
  success = dfs(numnode, E, Adj, discover, finish, list); 

  if (success) {
    for (i=1; i<=numnode; i++)
      printf("Node%d: discover time: %d, finish time: %d\n", 
	     i, discover[i], finish[i]);
    printf("Topological order:\n");
    item = list->head;
    while (item) {
      printf("%d ", (int)item->data);
      item = item->next;
    }
  }
  else printf("A cycle found.");
  printf("\n");

  graph_free(E);
  list_free(list);
  free(Adj);
  free(discover);
  free(finish);
  return(0);
}  
