#ifndef LIST_H
#define LIST_H

typedef struct list list_t;
typedef struct item list_item;

extern list_t *list_create();
extern void list_free(list_t *list);
extern void list_freeitems(list_t *list);

extern void list_append(list_t *list, void *data);
extern void list_append2head(list_t *list, void *data);
extern void list_append_before(list_t *list, list_item *item, void *data);
typedef int (*compare_fcn)(void *data1, void *data2);
extern void list_sort(list_t *list, compare_fcn compare);
extern unsigned int list_length(list_t *list);
extern void *list_extracthead(list_t *list);
extern void *list_deleteitem(list_t *list, list_item *item);

/* Internal use only */
extern list_item *_list_head(list_t *list);
extern list_item *_list_tail(list_t *list);
extern void *_list_data(list_item *item);
extern list_item *_list_next(list_item *item);

#define list_for_each(list, type, data) {\
 list_item *_it = _list_head(list);\
 while (_it) {\
   data = (type)_list_data(_it);\
   _it = _list_next(_it);

#define end_list_for_each }}

#endif
